--klein, sbox component

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY klein_sbox IS
  PORT(
    a_in  : IN STD_LOGIC_VECTOR(3 DOWNTO 0); --nibble (input)
    a_out : OUT STD_LOGIC_VECTOR(3 DOWNTO 0) --nibble (output, after sbox)
    );
END klein_sbox;

ARCHITECTURE rtl OF klein_sbox IS

BEGIN

  WITH a_in SELECT
    a_out <= "0111" WHEN "0000",
    "0100" WHEN "0001",
    "1010" WHEN "0010",
    "1001" WHEN "0011",
    "0001" WHEN "0100",
    "1111" WHEN "0101",
    "1011" WHEN "0110",
    "0000" WHEN "0111",
    "1100" WHEN "1000",
    "0011" WHEN "1001",
    "0010" WHEN "1010",
    "0110" WHEN "1011",
    "1000" WHEN "1100",
    "1110" WHEN "1101",
    "1101" WHEN "1110",
    "0101" WHEN OTHERS; --"1111";

END rtl;
