--klein, subnibbles step

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY klein_subnibbles IS
  PORT (                     --'0' encry. '1' decry.
    state_i  : IN STD_LOGIC_VECTOR(63 DOWNTO 0);   --state_i of the text
    state_o    : OUT STD_LOGIC_VECTOR(63 DOWNTO 0)   --output
    );
END klein_subnibbles;

ARCHITECTURE rtl OF klein_subnibbles IS

  SIGNAL a_i : STD_LOGIC_VECTOR(63 DOWNTO 0);
  
  COMPONENT klein_sbox IS
    PORT (
      a_in  : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
      a_out : OUT STD_LOGIC_VECTOR(3 DOWNTO 0) 
      );
  END COMPONENT;
  
  
BEGIN

  i_klein_sbox1 : klein_sbox
    PORT MAP (
      a_in  => state_i(3 DOWNTO 0),
      a_out => state_o(3 DOWNTO 0)
      );

   i_klein_sbox2 : klein_sbox
    PORT MAP (
      a_in  => state_i(7 DOWNTO 4),
      a_out => state_o(7 DOWNTO 4)
      );

   i_klein_sbox3 : klein_sbox
    PORT MAP (
      a_in  => state_i(11 DOWNTO 8),
      a_out => state_o(11 DOWNTO 8)
      );

   i_klein_sbox4 : klein_sbox
    PORT MAP (
      a_in  => state_i(15 DOWNTO 12),
      a_out => state_o(15 DOWNTO 12)
      );

   i_klein_sbox5 : klein_sbox
    PORT MAP (
      a_in  => state_i(19 DOWNTO 16),
      a_out => state_o(19 DOWNTO 16)
      );

   i_klein_sbox6 : klein_sbox
    PORT MAP (
      a_in  => state_i(23 DOWNTO 20),
      a_out => state_o(23 DOWNTO 20)
      );

   i_klein_sbox7 : klein_sbox
    PORT MAP (
      a_in  => state_i(27 DOWNTO 24),
      a_out => state_o(27 DOWNTO 24)
      );

   i_klein_sbox8 : klein_sbox
    PORT MAP (
      a_in  => state_i(31 DOWNTO 28),
      a_out => state_o(31 DOWNTO 28)
      );

   i_klein_sbox9 : klein_sbox
    PORT MAP (
      a_in  => state_i(35 DOWNTO 32),
      a_out => state_o(35 DOWNTO 32)
      );

   i_klein_sbox10 : klein_sbox
    PORT MAP (
      a_in  => state_i(39 DOWNTO 36),
      a_out => state_o(39 DOWNTO 36)
      );

   i_klein_sbox11 : klein_sbox
    PORT MAP (
      a_in  => state_i(43 DOWNTO 40),
      a_out => state_o(43 DOWNTO 40)
      );

   i_klein_sbox12 : klein_sbox
    PORT MAP (
      a_in  => state_i(47 DOWNTO 44),
      a_out => state_o(47 DOWNTO 44)
      );

   i_klein_sbox13 : klein_sbox
    PORT MAP (
      a_in  => state_i(51 DOWNTO 48),
      a_out => state_o(51 DOWNTO 48)
      );

   i_klein_sbox14 : klein_sbox
    PORT MAP (
      a_in  => state_i(55 DOWNTO 52),
      a_out => state_o(55 DOWNTO 52)
      );

   i_klein_sbox15 : klein_sbox
    PORT MAP (
      a_in  => state_i(59 DOWNTO 56),
      a_out => state_o(59 DOWNTO 56)
      );

   i_klein_sbox16 : klein_sbox
    PORT MAP (
      a_in  => state_i(63 DOWNTO 60),
      a_out => state_o(63 DOWNTO 60)
      );

 END rtl;
